/**
 * Created by wangjz on 2016/5/26.
 */
import reqwest from 'reqwest';
import message from 'antd/lib/message';
let ajax = function (param) {
    let hasErrorFunc = true;
    if (!param.error) {
		param.error = defaultError;
		hasErrorFunc = false;
	}
    if (!param.method) {
        param.method = 'get';
	}

    if (!param.success) {
        throw new Error("缺失ajax成功回调函数");
	}
    if (!param.url) {
        throw  new Error("缺失ajax必要参数url");
	}
    let sourceCallback = param.success;
    let callback = function (result) {
        if(!result.success && (result.code == '10000' || result.code == '500')) {
			if(!hasErrorFunc) {
				message.info(result.msg, 3);
			}else {
				param.error(result);
			}
        }else {
            sourceCallback(result);
        }
    }
	param.success = callback;

    reqwest(param);
}

let post = function (url, data, success, error) {
    let callback = (typeof data == 'function') ? data : success;
    if(typeof data == 'function' && typeof success == 'function') error = success;

    ajax({
        url: url,
        data: data,
        method: 'post',
        type: 'json',
        contentType: 'application/x-www-form-urlencoded',
        success: callback,
        error: error
    });
}

let postJson = function (url, data, success, error) {
    let callback = (typeof data == 'function') ? data : success;
    if(typeof data == 'function' && typeof success == 'function') error = success;

    ajax({
        url: url,
        data: data,
        method: 'post',
        type: 'json',
        contentType: 'application/json',
        success: callback,
        error: error
    });
}

let get = function (url, data, success, error) {
    let callback = (typeof data == 'function') ? data : success;
    if(typeof data == 'function' && typeof success == 'function') error = success;
    ajax({
        url: url,
        data: data,
        method: 'get',
        type: 'json',
        contentType: 'application/x-www-form-urlencoded',
        success: callback,
        error: error
    });
}

let getJson = function (url, data, success, error) {
    let callback = (typeof data == 'function') ? data : success;
    if(typeof data == 'function' && typeof success == 'function') error = success;
    ajax({
        url: url,
        data: data,
        method: 'get',
        type: 'json',
        contentType: 'application/json',
        success: callback,
        error: error
    });
}

let getp = function (url, data, success, error) {
    let callback = (typeof data == 'function') ? data : success;
    if(typeof data == 'function' && typeof success == 'function') error = success;

    ajax({
        url: url,
        data: data,
        method: 'get',
        type: 'jsonp',
        contentType: 'application/x-www-form-urlencoded',
        success: callback,
        error: error
    });
}


function defaultError(err) {
    message.error('请求数据发生错误！', 2);
    console.log(err);
}

let request = {
	ajax: ajax,
    get: get,
    post: post,
    getp: getp,
	getJson: getJson,
    postJson: postJson};

export default request;
